// Andreas Kirsch (c) 2006

uniform vec3 lightPosition;

varying vec3 lightDirection;
varying vec3 viewerDirection;
varying vec3 surfaceNormal;
varying vec2 texCoords;

void main() {
	gl_Position = ftransform();	
	
	vec3 viewVertex = vec3( gl_ModelViewMatrix * gl_Vertex ); 
	lightDirection = lightPosition - viewVertex;
	viewerDirection = vec3( 0.0, 0.0, 0.0 ) - viewVertex;
	surfaceNormal = gl_NormalMatrix * gl_Normal;	
		
	texCoords = vec2( gl_MultiTexCoord0 );
}